package cn.iocoder.yudao.module.mes.service.workreportplan;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.mes.controller.admin.producereportplan.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.workreportplan.ReportPlanSummaryDO;
import cn.iocoder.yudao.module.mes.dal.dataobject.workreportplan.ReportPlanViewDO;
import cn.iocoder.yudao.module.mes.dal.dataobject.workreportplan.WorkReportPlanDO;

import javax.validation.Valid;
import java.math.BigDecimal;
import java.util.List;

/**
 * 报工分配计划 Service 接口
 *
 * @author 内蒙必硕
 */
public interface WorkReportPlanService {

    /**
     * 创建报工分配计划
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createWorkReportPlan(@Valid WorkReportPlanSaveReqVO createReqVO);

    /**
     * 更新报工分配计划
     *
     * @param updateReqVO 更新信息
     */
    void updateWorkReportPlan(@Valid WorkReportPlanSaveReqVO updateReqVO);

    /**
     * 删除报工分配计划
     *
     * @param id 编号
     */
    void deleteWorkReportPlan(Long id);

    /**
     * 获得报工分配计划
     *
     * @param id 编号
     * @return 报工分配计划
     */
    WorkReportPlanDO getWorkReportPlan(Long id);

    /**
     * 获得报工分配计划分页
     *
     * @param pageReqVO 分页查询
     * @return 报工分配计划分页
     */
    PageResult<WorkReportPlanDO> getWorkReportPlanPage(WorkReportPlanPageReqVO pageReqVO);
    BigDecimal selectSumBy(Long planId, String orgType);

    public List<WorkReportPlanRespVO> buildVOList(List<WorkReportPlanDO> list);

    public List<ReportPlanViewDO> getReportPlanViewList();
    public PageResult<ReportPlanViewRespVO> getReportPlanViewPage(ReportPlanViewReqVO reqVO);
    List<ReportPlanViewRespVO> buildViewList(List<ReportPlanViewDO> list);

    List<ReportPlanSummaryRespVO> getPlanSummary(ReportPlanSummaryRespVO respVO);
    List<ReportPlanSummaryRespVO> buildSummaryList(List<ReportPlanSummaryDO> list);
}